/*
 * ȣХϥե
 *	ץ
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: aa_option.c,v 1.2 2000/09/04 01:18:39 tonton Exp $
 */

#include <gtk/gtk.h>
#include <libintl.h>

#include "wmc_ptype.h"

#include "acalz.h"
#include "aa_sdef.h"

static gchar		*Waao_ckey[] = {	// ѥ᡼()
						WAA_PRM_KEY_GRAPHFORE,
						WAA_PRM_KEY_GRAPHBACK,
						WAA_PRM_KEY_GRAPHMONTH,
						WAA_PRM_KEY_GRAPHWEEK,
						WAA_PRM_KEY_GRAPHDWEEK,
						WAA_PRM_KEY_GRAPHDATE,
						WAA_PRM_KEY_GRAPHTIME,
						WAA_PRM_KEY_GRAPHOS,
						WAA_PRM_KEY_GRAPHBRWS,
						WAA_PRM_KEY_GRAPHHOST,
						WAA_PRM_KEY_GRAPHREF,
						WAA_PRM_KEY_GRAPHPAGE
					};
static gchar		*Waao_fkey[] = {	// ѥ᡼(ե)
						WAA_PRM_KEY_FONTNAME,
						WAA_PRM_KEY_KANJIFONT
					};
static GtkAdjustment	*Waao_max_disp;	// ɽ
static GtkWidget	*Waao_ip;			// ɣХɥ쥹
static GtkWidget	*Waao_ip_btn[2];	// ɣʬܥ
static gint			Waao_div_ip;		// ɣХɥ쥹ʬ
static GtkWidget	*Waao_code_chg;		// 󡩡Ѵ
static GtkWidget	*Waao_small;		// ʸѴ
static GtkWidget	*Waao_index;		// index ̵뤹
static GtkWidget	*Waao_qst;			// ֡פ̵뤹
static GtkWidget	*Waao_sharp;		// ֡פ̵뤹
static GtkWidget	*Waao_portno;		// ݡ̵ֹ뤹
static GtkWidget	*Waao_sup_ftp;		// ưˣƣԣ
static GtkWidget	*Waao_sup_alz;		// ư˲
static GtkWidget	*Waao_sup_tile;		// ư˥ɽ
static GdkColor		Waao_color[WAA_MAX_WINNO + 2];
										// 
static GtkWidget	*Waao_ftext[2];		// ե̾

static void			waao_cb_ip_clicked(GtkWidget *, guint);
static void			waao_cb_ip_div_clicked(GtkWidget *, guint);
static void			waao_cb_modify_color(GtkWidget *, guint);
static void			waao_cb_font_change(GtkWidget *, guint);
static void			waao_cb_ok_clicked(GtkWidget *, gpointer, guint);
static GtkWidget	*waao_create_option_window(GtkWidget *);
static void			waao_set_button_color(GtkWidget *, gint);

/*===============
 *   ̾ : waa_cb_view_option()
 *     ǽ : ץꥦɥκ
 *    : ʤ
 */
void				waa_cb_view_option(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ᥤ󥦥ɥ
guint				call_data			// (I) ̤
)
{
	GtkWidget		*opt_window;		// ץꥦɥ
	gint			prm_cnt;			// ѥ᡼
	gint			loop_cnt;			// 롼ץ

	prm_cnt = sizeof(Waao_ckey) / sizeof(Waao_ckey[0]);
	for (loop_cnt = 0; loop_cnt < prm_cnt; loop_cnt++) {
		memcpy(&Waao_color[loop_cnt],
			waa_get_param(Waao_ckey[loop_cnt], 0), sizeof(GdkColor));
	}

	opt_window = waao_create_option_window(main_window);
	gtk_widget_show_all(opt_window);
}

/*===============
 *   ̾ : waao_cb_ip_clicked()
 *     ǽ : ɣХɥ쥹ܥ󲡲Хå
 *    : ʤ
 */
static void			waao_cb_ip_clicked(
GtkWidget			*button,			// (I) ܥ
guint				client_data			// (I) ̤
)
{
	gboolean		is_active;			// ܥ󲡲

	is_active = GTK_TOGGLE_BUTTON(button)->active ^ 1;
	gtk_widget_set_sensitive(Waao_ip_btn[0], is_active);
	gtk_widget_set_sensitive(Waao_ip_btn[1], is_active);
}

/*===============
 *   ̾ : waao_cb_ip_div_clicked()
 *     ǽ : ɣХɥ쥹ʬܥ󲡲Хå
 *    : ʤ
 */
static void			waao_cb_ip_div_clicked(
GtkWidget			*button,			// (I) ܥ
guint				button_no			// (I) ܥֹ
)
{
	gboolean		is_active;			// ܥ󲡲

	is_active = GTK_TOGGLE_BUTTON(button)->active;
	if (is_active == TRUE) {
		Waao_div_ip = button_no;
	}
}

/*===============
 *   ̾ : waao_cb_modify_color()
 *     ǽ : ѹܥ󲡲Хå
 *    : ʤ
 */
static void			waao_cb_modify_color(
GtkWidget			*button,			// (I) ܥ
guint				button_no			// (I) ֹ
)
{
	GdkColor		*set_color;			// 

	set_color = waa_modify_color(button, Waao_ckey[button_no]);
	memcpy(&Waao_color[button_no], set_color, sizeof(GdkColor));
	waao_set_button_color(button, button_no);
}

/*===============
 *   ̾ : waao_cb_font_change()
 *     ǽ : եѹܥ󲡲Хå
 *    : ʤ
 */
static void			waao_cb_font_change(
GtkWidget			*button,			// (I) ܥ
guint				button_no			// (I) Ⱦѡ
)
{
	gchar			*font_name;			// ե̾

	font_name = g_strconcat(
				gtk_entry_get_text(GTK_ENTRY(Waao_ftext[button_no])),
				NULL);
	font_name = waa_font_change(button, font_name);
	gtk_entry_set_text(GTK_ENTRY(Waao_ftext[button_no]), font_name);
	g_free(font_name);
}

/*===============
 *   ̾ : waao_cb_ok_clicked()
 *     ǽ : ܥ󲡲Хå
 *    : ʤ
 */
static void			waao_cb_ok_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			opt_window,			// (I) ץꥦɥ
guint				call_data			// (I) ̤
)
{
	void			(*set_func[])() = {	// ꥦɥ
						waa_modify_month_color_gc,
						waa_modify_week_color_gc,
						waa_modify_dweek_color_gc,
						waa_modify_date_color_gc,
						waa_modify_time_color_gc,
						waa_modify_os_color_gc,
						waa_modify_brws_color_gc,
						waa_modify_host_color_gc,
						waa_modify_ref_color_gc,
						waa_modify_page_color_gc
					};
	void			(*disp_func[])() = {// ɽɥ
						waa_draw_month,
						waa_draw_week,
						waa_draw_dweek,
						waa_draw_date,
						waa_draw_time,
						waa_draw_os,
						waa_draw_brws,
						waa_draw_host,
						waa_draw_ref,
						waa_draw_page
					};
	gint			opt_value;			// ץ
	gint			prm_cnt;			// ѥ᡼
	gint			loop_cnt;			// 롼ץ
	gint			func_loop;			// 롼ץ
	gchar			*font_name;			// ե̾

	opt_value = GTK_ADJUSTMENT(Waao_max_disp)->value;
	waa_put_param(WAA_PRM_KEY_MAXDISP, (void *)opt_value);

	opt_value = GTK_TOGGLE_BUTTON(Waao_ip)->active;
	waa_put_param(WAA_PRM_KEY_IGNOREIP, (void *)opt_value);
	waa_put_param(WAA_PRM_KEY_SPCCLASS, (void *)Waao_div_ip);

	opt_value = GTK_TOGGLE_BUTTON(Waao_code_chg)->active;
	waa_put_param(WAA_PRM_KEY_CODECHANGE, (void *)opt_value);

	opt_value = GTK_TOGGLE_BUTTON(Waao_small)->active;
	waa_put_param(WAA_PRM_KEY_SMALLIZE, (void *)opt_value);

	opt_value = GTK_TOGGLE_BUTTON(Waao_index)->active;
	waa_put_param(WAA_PRM_KEY_IGNOREINDEX, (void *)opt_value);

	opt_value = GTK_TOGGLE_BUTTON(Waao_qst)->active;
	waa_put_param(WAA_PRM_KEY_IGNOREQUESTION, (void *)opt_value);

	opt_value = GTK_TOGGLE_BUTTON(Waao_sharp)->active;
	waa_put_param(WAA_PRM_KEY_IGNORESHARP, (void *)opt_value);

	opt_value = GTK_TOGGLE_BUTTON(Waao_portno)->active;
	waa_put_param(WAA_PRM_KEY_IGNOREPORTNO, (void *)opt_value);

	opt_value = GTK_TOGGLE_BUTTON(Waao_sup_ftp)->active;
	waa_put_param(WAA_PRM_KEY_AUTOFTP, (void *)opt_value);

	opt_value = GTK_TOGGLE_BUTTON(Waao_sup_alz)->active;
	waa_put_param(WAA_PRM_KEY_AUTOANALYZE, (void *)opt_value);

	opt_value = GTK_TOGGLE_BUTTON(Waao_sup_tile)->active;
	waa_put_param(WAA_PRM_KEY_AUTOTILE, (void *)opt_value);

	prm_cnt = sizeof(Waao_ckey) / sizeof(Waao_ckey[0]);
	for (loop_cnt = 0; loop_cnt < prm_cnt; loop_cnt++) {
		waa_put_param(Waao_ckey[loop_cnt], &Waao_color[loop_cnt]);
	}

	prm_cnt = sizeof(Waao_fkey) / sizeof(Waao_fkey[0]);
	for (loop_cnt = 0; loop_cnt < prm_cnt; loop_cnt++) {
		font_name = g_strconcat(
			gtk_entry_get_text(GTK_ENTRY(Waao_ftext[loop_cnt])), NULL);
		waa_put_param(Waao_fkey[loop_cnt], font_name);
		g_free(font_name);
	}
	gtk_widget_destroy(opt_window);

	// 󹹿
	prm_cnt = sizeof(set_func) / sizeof(set_func[0]);
	for (func_loop = 0; func_loop < prm_cnt; func_loop++) {
		for (loop_cnt = 0; loop_cnt < 3; loop_cnt++) {
			set_func[func_loop](loop_cnt);
		}
	}

	// 
	prm_cnt = sizeof(disp_func) / sizeof(disp_func[0]);
	for (func_loop = 0; func_loop < prm_cnt; func_loop++) {
		disp_func[func_loop]();
	}
}

/*===============
 *   ̾ : waao_create_option_window()
 *     ǽ : ɥ
 *    : ɥ
 */
static GtkWidget	*waao_create_option_window(
GtkWidget			*parent				// (I) ƥɥ
)
{
	gchar			*color_btn_str[] = {// ܥ
						WAA_STR_OPT_FORE,
						WAA_STR_OPT_BACK,
						WAA_STR_OPT_MONTH,
						WAA_STR_OPT_WEEK,
						WAA_STR_OPT_DWEEK,
						WAA_STR_OPT_DATE,
						WAA_STR_OPT_TIME,
						WAA_STR_OPT_OS,
						WAA_STR_OPT_BRWS,
						WAA_STR_OPT_HOST,
						WAA_STR_OPT_REF,
						WAA_STR_OPT_PAGE
					};
	gchar			*font_str[] = {		// եȥ٥
						WAA_STR_OPT_FONT,
						WAA_STR_OPT_KFONT
					};
	GtkWidget		*opt_window;		// ɥ
	gint			decorations;		// ɥǥ졼
	GtkWidget		*opt_vbox;			//
	gboolean		bool_value;			// ץ
	GtkWidget		*opt_tab;			// ץ󥿥
	GtkWidget		*tab_alz;			// Ͼ󥿥
	GtkWidget		*alz_vbox;			//
	GtkWidget		*item_hbox;			//
	gdouble			max_disp;			// ɽ
	GSList			*ip_group;			//
	GtkWidget		*opt_spin;			//
	GtkWidget		*tab_disp;			// ɽ
	GtkWidget		*frame_disp;		//
	GtkWidget		*disp_vbox;			//
	gint			v_loop;				// 롼ץ
	gint			h_loop;				// 롼ץ
	gint			button_no;			// ܥֹ
	GtkWidget		*color_table;		// ơ֥
	GtkWidget		*item_vbox;			//
	GtkWidget		*item_label;		// ٥
	GtkWidget		*item_button;		// ܥ
	GtkWidget		*font_vbox;			// եȥܥå
	GtkWidget		*font_hbox;			//
	GtkWidget		*font_label;		// եȥ٥
	gchar			*font_name;			// ե̾
	GtkWidget		*font_button;		// եȥܥ
	gint			loop_cnt;			// 롼ץ
	GtkWidget		*btn_hbox;			// ܥܥå
	GtkWidget		*ok_btn;			// ܥ
	GtkWidget		*cancel_btn;		// ߥܥ
	gchar			*title;				// ȥʸ

	// ɥ
	title = g_strconcat(_(WAA_TT_OPTION), NULL);
	opt_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(opt_window), title);
	gtk_window_set_position(GTK_WINDOW(opt_window),
							GTK_WIN_POS_MOUSE);
	gtk_window_set_policy(GTK_WINDOW(opt_window), TRUE, TRUE, FALSE);
	gtk_widget_realize(opt_window);
	decorations = GDK_DECOR_BORDER | GDK_DECOR_TITLE |
					GDK_DECOR_MENU | GDK_DECOR_MINIMIZE;
	gdk_window_set_decorations(opt_window->window, decorations);
	decorations = GDK_FUNC_MOVE | GDK_FUNC_MINIMIZE | GDK_FUNC_CLOSE;
	gdk_window_set_functions(opt_window->window, decorations);
	g_free(title);

	// 
	opt_vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(opt_vbox), 5);
	gtk_container_add(GTK_CONTAINER(opt_window), opt_vbox);
	opt_tab = gtk_notebook_new();
	gtk_box_pack_start(GTK_BOX(opt_vbox), opt_tab, TRUE, TRUE, 3);

	// Ͼ
	tab_alz = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(opt_tab), tab_alz);
	item_label = gtk_label_new(_(WAA_STR_OPT_ALZ));
	gtk_notebook_set_tab_label(GTK_NOTEBOOK(opt_tab),
		gtk_notebook_get_nth_page(GTK_NOTEBOOK(opt_tab), 0),
		item_label);
	alz_vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(alz_vbox), 10);
	gtk_box_pack_start(GTK_BOX(tab_alz), alz_vbox, TRUE, TRUE, 0);

	// ɽ
	item_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(alz_vbox), item_hbox, FALSE, FALSE, 0);
	item_label = gtk_label_new(_(WAA_STR_OPT_MAXDSP1));
	gtk_box_pack_start(GTK_BOX(item_hbox), item_label, FALSE, FALSE, 0);

	max_disp = (gdouble)((gint)waa_get_param(WAA_PRM_KEY_MAXDISP, 0));
	Waao_max_disp = (GtkAdjustment *)gtk_adjustment_new(max_disp,
										1.0, 999.0, 1.0, 5.0, 0.0);
	opt_spin = gtk_spin_button_new(Waao_max_disp, 0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(opt_spin), TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(opt_spin),
 									GTK_SHADOW_ETCHED_IN);
	gtk_widget_set_usize(GTK_WIDGET(opt_spin), 55, 0);
	gtk_box_pack_start(GTK_BOX(item_hbox), opt_spin, FALSE, FALSE, 5);

	item_label = gtk_label_new(_(WAA_STR_OPT_MAXDSP2));
	gtk_box_pack_start(GTK_BOX(item_hbox), item_label, FALSE, FALSE, 0);

	item_label = gtk_label_new(_(WAA_STR_OPT_MAXDSP3));
	gtk_box_pack_start(GTK_BOX(item_hbox), item_label, FALSE, FALSE, 5);

	// ɣХɥ쥹
	item_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(alz_vbox), item_hbox, FALSE, FALSE, 0);
	Waao_ip = gtk_check_button_new_with_label(_(WAA_STR_OPT_IP1));
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Waao_ip),
					(gboolean)waa_get_param(WAA_PRM_KEY_IGNOREIP, 0));
	gtk_box_pack_start(GTK_BOX(item_hbox), Waao_ip, FALSE, FALSE, 0);
	item_label = gtk_label_new(_(WAA_STR_OPT_IP2));
	gtk_box_pack_start(GTK_BOX(item_hbox), item_label, FALSE, FALSE, 0);

	item_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(alz_vbox), item_hbox, FALSE, FALSE, 0);
	Waao_ip_btn[0] =
		gtk_radio_button_new_with_label(NULL, _(WAA_STR_OPT_IP3));
	gtk_box_pack_start(GTK_BOX(item_hbox),
			Waao_ip_btn[0], TRUE, TRUE, 10);
	bool_value = (gboolean)waa_get_param(WAA_PRM_KEY_SPCCLASS, 0);
	if (bool_value == TRUE) {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Waao_ip_btn[0]),
															TRUE);
	}
	gtk_signal_connect(GTK_OBJECT(Waao_ip_btn[0]), "clicked",
						GTK_SIGNAL_FUNC(waao_cb_ip_div_clicked),
						GUINT_TO_POINTER(1));

	ip_group = gtk_radio_button_group(GTK_RADIO_BUTTON(Waao_ip_btn[0]));
	Waao_ip_btn[1] = gtk_radio_button_new_with_label(ip_group,
									_(WAA_STR_OPT_IP4));
	gtk_box_pack_start(GTK_BOX(item_hbox), Waao_ip_btn[1], TRUE, TRUE, 0);
	if (bool_value == FALSE) {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Waao_ip_btn[1]),
															TRUE);
	}
	gtk_signal_connect(GTK_OBJECT(Waao_ip_btn[1]), "clicked",
						GTK_SIGNAL_FUNC(waao_cb_ip_div_clicked),
						GUINT_TO_POINTER(0));
	gtk_signal_connect(GTK_OBJECT(Waao_ip), "clicked",
						GTK_SIGNAL_FUNC(waao_cb_ip_clicked),
						NULL);
	waao_cb_ip_clicked(Waao_ip, 0);

	// 󡩡򥳡Ѵ
	item_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(alz_vbox), item_hbox, FALSE, FALSE, 0);
	Waao_code_chg =
		gtk_check_button_new_with_label(_(WAA_STR_OPT_CCHG1));
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Waao_code_chg),
				(gboolean)waa_get_param(WAA_PRM_KEY_CODECHANGE, 0));
	gtk_box_pack_start(GTK_BOX(item_hbox),
			Waao_code_chg, FALSE, FALSE, 0);
	item_label = gtk_label_new(_(WAA_STR_OPT_CCHG2));
	gtk_box_pack_start(GTK_BOX(item_hbox), item_label, FALSE, FALSE, 0);

	// ʸѴ
	item_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(alz_vbox), item_hbox, FALSE, FALSE, 0);
	Waao_small = gtk_check_button_new_with_label(_(WAA_STR_OPT_SMALL1));
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Waao_small),
				(gboolean)waa_get_param(WAA_PRM_KEY_SMALLIZE, 0));
	gtk_box_pack_start(GTK_BOX(item_hbox),
			Waao_small, FALSE, FALSE, 0);
	item_label = gtk_label_new(_(WAA_STR_OPT_SMALL2));
	gtk_box_pack_start(GTK_BOX(item_hbox), item_label, FALSE, FALSE, 0);

	// index ̵뤹
	item_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(alz_vbox), item_hbox, FALSE, FALSE, 0);
	Waao_index = gtk_check_button_new_with_label(_(WAA_STR_OPT_INDEX1));
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Waao_index),
				(gboolean)waa_get_param(WAA_PRM_KEY_IGNOREINDEX, 0));
	gtk_box_pack_start(GTK_BOX(item_hbox),
			Waao_index, FALSE, FALSE, 0);
	item_label = gtk_label_new(_(WAA_STR_OPT_INDEX2));
	gtk_box_pack_start(GTK_BOX(item_hbox), item_label, FALSE, FALSE, 0);

	// ֡פ̵뤹
	item_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(alz_vbox), item_hbox, FALSE, FALSE, 0);
	Waao_qst = gtk_check_button_new_with_label(_(WAA_STR_OPT_QST1));
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Waao_qst),
				(gboolean)waa_get_param(WAA_PRM_KEY_IGNOREQUESTION, 0));
	gtk_box_pack_start(GTK_BOX(item_hbox),
			Waao_qst, FALSE, FALSE, 0);
	item_label = gtk_label_new(_(WAA_STR_OPT_QST2));
	gtk_box_pack_start(GTK_BOX(item_hbox), item_label, FALSE, FALSE, 0);

	// ֡פ̵뤹
	item_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(alz_vbox), item_hbox, FALSE, FALSE, 0);
	Waao_sharp = gtk_check_button_new_with_label(_(WAA_STR_OPT_SHARP1));
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Waao_sharp),
				(gboolean)waa_get_param(WAA_PRM_KEY_IGNORESHARP, 0));
	gtk_box_pack_start(GTK_BOX(item_hbox),
			Waao_sharp, FALSE, FALSE, 0);
	item_label = gtk_label_new(_(WAA_STR_OPT_SHARP2));
	gtk_box_pack_start(GTK_BOX(item_hbox), item_label, FALSE, FALSE, 0);

	// ݡ̵ֹ뤹
	item_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(alz_vbox), item_hbox, FALSE, FALSE, 0);
	Waao_portno =
		gtk_check_button_new_with_label(_(WAA_STR_OPT_PORTNO1));
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Waao_portno),
				(gboolean)waa_get_param(WAA_PRM_KEY_IGNOREPORTNO, 0));
	gtk_box_pack_start(GTK_BOX(item_hbox),
			Waao_portno, FALSE, FALSE, 0);
	item_label = gtk_label_new(_(WAA_STR_OPT_PORTNO2));
	gtk_box_pack_start(GTK_BOX(item_hbox), item_label, FALSE, FALSE, 0);

	// ưˡ
	item_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(alz_vbox), item_hbox, FALSE, FALSE, 0);
	item_label = gtk_label_new(_(WAA_STR_OPT_SUP1));
	gtk_box_pack_start(GTK_BOX(item_hbox), item_label, FALSE, FALSE, 5);

	Waao_sup_ftp =
		gtk_check_button_new_with_label(_(WAA_STR_OPT_SUPFTP));
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Waao_sup_ftp),
				(gboolean)waa_get_param(WAA_PRM_KEY_AUTOFTP, 0));
	gtk_box_pack_start(GTK_BOX(item_hbox),
			Waao_sup_ftp, FALSE, FALSE, 0);

	Waao_sup_alz =
		gtk_check_button_new_with_label(_(WAA_STR_OPT_SUPALZ));
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Waao_sup_alz),
				(gboolean)waa_get_param(WAA_PRM_KEY_AUTOANALYZE, 0));
	gtk_box_pack_start(GTK_BOX(item_hbox),
			Waao_sup_alz, FALSE, FALSE, 0);

	Waao_sup_tile =
		gtk_check_button_new_with_label(_(WAA_STR_OPT_SUPTILE));
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Waao_sup_tile),
				(gboolean)waa_get_param(WAA_PRM_KEY_AUTOTILE, 0));
	gtk_box_pack_start(GTK_BOX(item_hbox),
			Waao_sup_tile, FALSE, FALSE, 0);

	// 
	item_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(alz_vbox), item_hbox, FALSE, FALSE, 10);
	item_label = gtk_label_new(_(WAA_STR_OPT_REM1));
	gtk_box_pack_start(GTK_BOX(item_hbox), item_label, FALSE, FALSE, 0);

	// ɽ
	tab_disp = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(opt_tab), tab_disp);
	item_label = gtk_label_new(_(WAA_STR_OPT_DISP));
	gtk_notebook_set_tab_label(GTK_NOTEBOOK(opt_tab),
		gtk_notebook_get_nth_page(GTK_NOTEBOOK(opt_tab), 1),
		item_label);
	disp_vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(disp_vbox), 10);
	gtk_box_pack_start(GTK_BOX(tab_disp), disp_vbox, TRUE, TRUE, 0);
	frame_disp = gtk_frame_new(_(WAA_STR_OPT_COLOR));
	gtk_box_pack_start(GTK_BOX(disp_vbox), frame_disp, TRUE, TRUE, 3);

	// ɽ
	color_table = gtk_table_new(3, 4, TRUE);
	gtk_container_add(GTK_CONTAINER(frame_disp), color_table);
	gtk_table_set_row_spacings(GTK_TABLE(color_table), 5);
	gtk_table_set_col_spacings(GTK_TABLE(color_table), 10);
	button_no = 0;
	for (v_loop = 0; v_loop < 3/**/; v_loop++) {
		for (h_loop = 0; h_loop < 4/**/; h_loop++) {
			item_vbox = gtk_vbox_new(FALSE, 0);
			gtk_table_attach_defaults(GTK_TABLE(color_table), item_vbox,
					h_loop, h_loop + 1, v_loop, v_loop + 1); 
			item_label = gtk_label_new(_(color_btn_str[button_no]));
			gtk_misc_set_alignment(GTK_MISC(item_label), 0, 0);
			gtk_box_pack_start(GTK_BOX(item_vbox),
						item_label, FALSE, FALSE, 0);
			item_button = gtk_button_new_with_label(NULL);
			waao_set_button_color(item_button, button_no);
			gtk_box_pack_start(GTK_BOX(item_vbox),
						item_button, FALSE, FALSE, 0);
			gtk_signal_connect(GTK_OBJECT(item_button), "clicked",
							GTK_SIGNAL_FUNC(waao_cb_modify_color),
							GUINT_TO_POINTER(button_no));
			button_no++;
		}
	}

	// ե
	for (loop_cnt = 0; loop_cnt < 2/*Ⱦѡ*/; loop_cnt++) {
		font_hbox = gtk_hbox_new(FALSE, 0);
		gtk_box_pack_start(GTK_BOX(disp_vbox),
					font_hbox, TRUE, TRUE, 5);
		font_vbox = gtk_vbox_new(FALSE, 0);
		gtk_container_set_border_width(GTK_CONTAINER(font_vbox), 10);
		gtk_box_pack_start(GTK_BOX(font_hbox),
					font_vbox, TRUE, TRUE, 0);
		font_label = gtk_label_new(_(font_str[loop_cnt]));
		gtk_misc_set_alignment(GTK_MISC(font_label), 0, 0);
		gtk_box_pack_start(GTK_BOX(font_vbox),
					font_label, FALSE, FALSE, 0);

		Waao_ftext[loop_cnt] = gtk_entry_new();
		font_name = waa_get_param(Waao_fkey[loop_cnt], 0);
		gtk_entry_set_text(GTK_ENTRY(Waao_ftext[loop_cnt]), font_name);
		gtk_box_pack_start(GTK_BOX(font_vbox),
			Waao_ftext[loop_cnt], FALSE, FALSE, 0);

		font_vbox = gtk_vbox_new(TRUE, 0);
		gtk_box_pack_start(GTK_BOX(font_hbox),
					font_vbox, TRUE, TRUE, 0);

		font_button = gtk_button_new_with_label(_(WAA_STR_BTN_CHANGE));
		gtk_box_pack_start(GTK_BOX(font_vbox),
					font_button, FALSE, FALSE, 0);
		gtk_signal_connect(GTK_OBJECT(font_button), "clicked",
						GTK_SIGNAL_FUNC(waao_cb_font_change),
						GUINT_TO_POINTER(loop_cnt));
	}

	// ꡿ߥܥ
	btn_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_end(GTK_BOX(opt_vbox), btn_hbox, FALSE, TRUE, 5);

	cancel_btn = gtk_button_new_with_label(_(WAA_STR_BTN_CANCEL));
	gtk_box_pack_end(GTK_BOX(btn_hbox), cancel_btn, FALSE, TRUE, 5);
	gtk_signal_connect(GTK_OBJECT(cancel_btn), "clicked",
						GTK_SIGNAL_FUNC(wmc_dialog_close_clicked),
						GTK_OBJECT(opt_window));
	GTK_WIDGET_SET_FLAGS(cancel_btn, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(cancel_btn);

	ok_btn = gtk_button_new_with_label(_(WAA_STR_BTN_SET));
	gtk_box_pack_end(GTK_BOX(btn_hbox), ok_btn, FALSE, TRUE, 5);
	gtk_signal_connect(GTK_OBJECT(ok_btn), "clicked",
						GTK_SIGNAL_FUNC(waao_cb_ok_clicked),
						GTK_OBJECT(opt_window));
	GTK_WIDGET_SET_FLAGS(ok_btn, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(ok_btn);

	gtk_window_set_modal(GTK_WINDOW(opt_window), TRUE);
	gtk_window_set_transient_for(GTK_WINDOW(opt_window),
								GTK_WINDOW(parent));

	return opt_window;
}

/*===============
 *   ̾ : waao_set_button_color()
 *     ǽ : ܥ󿧤ѹ
 *    : ʤ
 */
static void			waao_set_button_color(
GtkWidget			*button_widget,		// (I/O) ܥ
gint				button_no			// ( I ) ܥֹ
)
{
	GtkStyle		*btn_style;			// ꥹ
	gint			loop_cnt;			// 롼ץ

	btn_style = gtk_style_copy(gtk_widget_get_style(button_widget));
	for (loop_cnt = 0; loop_cnt < 5; loop_cnt++) {
		btn_style->bg[loop_cnt] = Waao_color[button_no];
	}
	gtk_widget_set_style(button_widget, btn_style);
	gtk_style_unref(btn_style);
}
