/*
 * ȣХϥե
 *	ɽ
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: aa_color.c,v 1.1 2000/08/25 11:52:42 tonton Exp $
 */

#include <gtk/gtk.h>
#include <libintl.h>

#include "wmc_ptype.h"

#include "acalz.h"
#include "aa_sdef.h"

static gchar		*Waac_color_no;		// ֹ	
static GdkColor		Waac_set_color;		// ꤹ뿧

static GtkWidget	*waac_create_color_window(GtkWidget *);
static void			waac_cb_destroy(void);
static void			waac_cb_ok_clicked(GtkWidget *, gpointer, guint);

/*===============
 *   ̾ : waa_modify_color()
 *     ǽ : 򥦥ɥκ
 *    : ʤ
 */
GdkColor			*waa_modify_color(
GtkWidget			*button,			// (I) ܥ
gchar				*color_no			// (I) ֹ
)
{
	GtkWidget		*parent_window;		// ƥɥ
	GtkWidget		*color_window;		// 򥦥ɥ

	if (Waac_color_no) {
		g_free(Waac_color_no);
	}
	Waac_color_no = g_strconcat(color_no, NULL);
	parent_window = GTK_WIDGET(button)->parent;
	while (!GTK_IS_WINDOW(parent_window)) {
		parent_window = GTK_WIDGET(parent_window)->parent;
	}
	color_window = waac_create_color_window(parent_window);
	gtk_widget_show(color_window);
	gtk_main();

	return &Waac_set_color;
}

/*===============
 *   ̾ : waac_cb_destroy()
 *     ǽ : ɥ˲Хå
 *    : ʤ
 */
static void			waac_cb_destroy(void)
{
	g_free(Waac_color_no);
	Waac_color_no = NULL;
	gtk_main_quit();
}

/*===============
 *   ̾ : waac_cb_ok_clicked()
 *     ǽ : ܥ󲡲Хå
 *    : ʤ
 */
static void			waac_cb_ok_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ꥦɥ
guint				call_data			// (I) ̤
)
{
	GtkColorSelectionDialog
					*color_window;		// 򥦥ɥ
	GtkColorSelection	*colorsel;		//
	gdouble			spc_color[4];		// 򤷤

	color_window = (GtkColorSelectionDialog *)main_window;
	colorsel = GTK_COLOR_SELECTION(color_window->colorsel);
	gtk_color_selection_get_color(colorsel, spc_color);

	memset(&Waac_set_color, 0, sizeof(GdkColor));
	Waac_set_color.red = (guint)(spc_color[0] * (guint)0xffff);
	Waac_set_color.green = (guint)(spc_color[1] * (guint)0xffff);
	Waac_set_color.blue = (guint)(spc_color[2] * (guint)0xffff);

	gtk_widget_destroy(main_window);
}

/*===============
 *   ̾ : waac_create_color_window()
 *     ǽ : ɥ
 *    : ɥ
 */
static GtkWidget	*waac_create_color_window(
GtkWidget			*parent				// (I) ƥɥ
)
{
	GtkWidget		*color_window;		// ɥ
	GtkColorSelection	*colorsel;		//
	gdouble			spc_color[4];		// ꤹ뿧
	GtkWidget		*ok_btn;			// ܥ
	GtkWidget		*cancel_btn;		// ߥܥ
	gchar			*title;				// ȥʸ

	// ɥ
	title = g_strconcat(_(WAA_TT_COLOR), NULL);
	color_window = gtk_color_selection_dialog_new(title);
	gtk_window_set_position(GTK_WINDOW(color_window),
							GTK_WIN_POS_MOUSE);
	gtk_container_set_border_width(GTK_CONTAINER(color_window), 10);
	gtk_signal_connect(GTK_OBJECT(color_window), "destroy",
						GTK_SIGNAL_FUNC(waac_cb_destroy),
						GTK_OBJECT(color_window));
	g_free(title);

	// 
	memcpy(&Waac_set_color,
		waa_get_param(Waac_color_no, 0), sizeof(GdkColor));
	spc_color[0] = (gdouble)Waac_set_color.red / (guint)0xffff;
	spc_color[1] = (gdouble)Waac_set_color.green / (guint)0xffff;
	spc_color[2] = (gdouble)Waac_set_color.blue / (guint)0xffff;
	colorsel = GTK_COLOR_SELECTION(((GtkColorSelectionDialog *)color_window)->colorsel);
	gtk_color_selection_set_color(colorsel, spc_color);

	// ܥ
	ok_btn = GTK_COLOR_SELECTION_DIALOG(color_window)->ok_button;
	gtk_widget_show(ok_btn);
	GTK_WIDGET_SET_FLAGS(ok_btn, GTK_CAN_DEFAULT);
	gtk_signal_connect(GTK_OBJECT(ok_btn), "clicked",
						GTK_SIGNAL_FUNC(waac_cb_ok_clicked),
						GTK_OBJECT(color_window));

	cancel_btn = GTK_COLOR_SELECTION_DIALOG(color_window)->cancel_button;
	gtk_widget_show(cancel_btn);
	GTK_WIDGET_SET_FLAGS(cancel_btn, GTK_CAN_DEFAULT);
	gtk_signal_connect(GTK_OBJECT(cancel_btn), "clicked",
						GTK_SIGNAL_FUNC(wmc_dialog_close_clicked),
						GTK_OBJECT(color_window));

	gtk_widget_grab_default(ok_btn);

	gtk_window_set_modal(GTK_WINDOW(color_window), TRUE);
	gtk_window_set_transient_for(GTK_WINDOW(color_window),
								GTK_WINDOW(parent));

	return color_window;
}
