/*
 * ȣХϥե
 *	ե
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: aa_fsel.c,v 1.1 2000/08/15 00:34:46 tonton Exp $
 */

#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <libintl.h>

#include "wmc_ptype.h"

#include "acalz.h"
#include "aa_sdef.h"

GtkWidget			*Waaf_win;			// ե򥦥ɥ
static gint			Waaf_win_type;		// ɥ

static void			waaf_cb_destroy(void);
static void			waaf_cb_ok_clicked(GtkWidget *, GtkFileSelection *);
static void			waaf_cb_cancel_clicked(GtkWidget *,
										gpointer, guint);
static GtkWidget	*waaf_create_fsel_window(GtkWidget *, gchar *, gchar *);

/*===============
 *   ̾ : waa_cb_mfile_fsel_clicked()
 *     ǽ : ե򥦥ɥκ
 *    : ʤ
 */
void				waa_cb_mfile_fsel_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ᥤ󥦥ɥ
guint				win_type			// (I) ץ¸
)
{
	gchar			*file_name;			// ե̾
	gchar			*title;				// ȥʸ

	Waaf_win_type = win_type;
	if (win_type == WAA_FSEL_OPEN) {
		title = g_strconcat(_(WAA_TT_FILEOPEN), NULL);
		file_name = waa_get_param(WAA_PRM_KEY_LOGFILE, 0);
	}
	else {
		title = g_strconcat(_(WAA_TT_FILESAVE), NULL);
		file_name = NULL;
	}
	Waaf_win = waaf_create_fsel_window(main_window, title, file_name);
	g_free(title);
	gtk_widget_show_all(Waaf_win);
	gtk_main();
}

/*===============
 *   ̾ : waaf_cb_destroy()
 *     ǽ : ɥ˲Хå
 *    : ʤ
 */
static void			waaf_cb_destroy(void)
{
	gtk_main_quit();
}

/*===============
 *   ̾ : waaf_cb_ok_clicked()
 *     ǽ : λܥ󲡲Хå
 *    : ʤ
 */
static void			waaf_cb_ok_clicked(
GtkWidget			*button,			// (I) ܥ
GtkFileSelection	*file_sel			// (I) 
)
{
	gboolean		write_ok;			// 񤭹ߥե饰
	gchar			*file_name;			// ե̾

	file_name =
		gtk_file_selection_get_filename(GTK_FILE_SELECTION(Waaf_win));
	if (Waaf_win_type == WAA_FSEL_OPEN) {
		waa_put_param(WAA_PRM_KEY_LOGFILE, file_name);
		waa_create_logfile();
	}
	else {
		write_ok = TRUE;
		if (access(file_name, R_OK) >= 0) {
			write_ok = wmc_create_qmsg_dialog(Waaf_win,
						_(WAA_STR_QUESTION), _(WAA_STR_QST_SMSEL));
		}
		if (write_ok == TRUE) {
			waa_write_access_file(file_name);
		}
	}

	gtk_widget_destroy(Waaf_win);
}

/*===============
 *   ̾ : waaf_cb_cancel_clicked()
 *     ǽ : åܥ󲡲Хå
 *    : ʤ
 */
static void			waaf_cb_cancel_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ե򥦥ɥ
guint				call_data			// (I) ̤
)
{
	gtk_widget_destroy(main_window);
}

/*===============
 *   ̾ : waaf_create_fsel_window()
 *     ǽ : ɥ
 *    : ɥ
 */
static GtkWidget	*waaf_create_fsel_window(
GtkWidget			*parent,			// (I) ƥɥ
gchar				*title,				// (I) ɽȥ
gchar				*file_name			// (I) ɽե̾
)
{
	GtkWidget		*fsel_window;		// ե򥦥ɥ
	GtkObject		*ok_button;			// λܥ
	GtkObject		*cancel_button;		// åܥ

	// ɥ
	fsel_window = gtk_file_selection_new(title);
	gtk_signal_connect(GTK_OBJECT(fsel_window), "destroy",
					GTK_SIGNAL_FUNC(waaf_cb_destroy), NULL);

	// ܥ
	ok_button = GTK_OBJECT(GTK_FILE_SELECTION(fsel_window)->ok_button);
	gtk_signal_connect(ok_button, "clicked",
				GTK_SIGNAL_FUNC(waaf_cb_ok_clicked), fsel_window);

	cancel_button =
		GTK_OBJECT(GTK_FILE_SELECTION(fsel_window)->cancel_button);
	gtk_signal_connect(cancel_button, "clicked",
				GTK_SIGNAL_FUNC(waaf_cb_cancel_clicked), fsel_window);

	if (file_name != NULL) {
		gtk_file_selection_set_filename(GTK_FILE_SELECTION(fsel_window),
															file_name);
	}

	if (parent != NULL) {
		gtk_window_set_modal(GTK_WINDOW(fsel_window), TRUE);
		gtk_window_set_transient_for(GTK_WINDOW(fsel_window),
									GTK_WINDOW(parent));
	}

	return fsel_window;
}
