/*
 * ȣХϥե
 *	ڡ̲ϥɥ
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: aa_page.c,v 1.3 2000/09/04 01:18:39 tonton Exp $
 */

#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <libintl.h>

#include "wmc_ptype.h"

#include "acalz.h"
#include "aa_sdef.h"

static GtkWidget	*Waap_win;				// ڡ̲ϥɥ
static GtkWidget	*Waap_darea;			// 襨ꥢ
static GdkPixmap	*Waap_pixmap = NULL;	// 襨ꥢ
static GdkGC		*Waap_gc_color[] = {	// ɽ
						NULL, NULL, NULL
					};
static GdkFont		*Waap_font = NULL;		// ե
static GdkFont		*Waap_kfont = NULL;		// ܸե

static GtkWidget	*waap_create_page_window(GtkWidget *);
static void			waap_cb_destroy_window(void);
static void			waap_cb_darea_move(GtkWidget *, GdkEvent *);
static gint			waap_cb_darea_expose(GtkWidget *, GdkEventExpose *);
static gint			waap_cb_darea_config(GtkWidget *,
										GdkEventConfigure *);
static void			waap_create_gc(GtkWidget *);
static void			waap_draw_page(gint, gint, gint, gint);

/*===============
 *   ̾ : waa_cb_view_page()
 *     ǽ : ڡ̲ϥɥκ
 *    : ʤ
 */
void				waa_cb_view_page(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ᥤ󥦥ɥ
guint				call_data			// (I) ̤
)
{
	gint			vis_win;			// ɽΥɥ

	if (Waap_win != NULL) {
		wmc_window_set_focus(Waap_win);
	}
	else {
		Waap_win = waap_create_page_window(main_window);
		gtk_widget_show_all(Waap_win);
	}

	vis_win = (gint)waa_get_param(WAA_PRM_KEY_VISWINDOW, 0);
	vis_win |= WAA_WINNO_PAGE;
	waa_put_param(WAA_PRM_KEY_VISWINDOW, (void *)vis_win);
}

/*===============
 *   ̾ : waa_move_page()
 *     ǽ : ڡ̥̤ΰưꥵ
 *    : ʤ
 */
void				waa_move_page(
gint				decorations,		// (I) Ȥ
gint				pos_x,				// (I) ưɸ
gint				pos_y,				// (I) ưɸ
gint				width,				// (I) ɥ
gint				height				// (I) ɥ⤵
)
{
	wmc_window_decorations(Waap_win,
		decorations, pos_x, pos_y, width, height);
}

/*===============
 *   ̾ : waa_draw_page()
 *     ǽ : ڡ̥(ƽ)
 *    : ʤ
 */
void				waa_draw_page(void)
{
	gint			width;				// 襨ꥢ
	gint			height;				// 襨ꥢ⤵

	if (Waap_pixmap != NULL) {
		width = (gint)waa_get_param(WAA_PRM_KEY_PAGEWIDTH, 0);
		height = (gint)waa_get_param(WAA_PRM_KEY_PAGEHEIGHT, 0);

		if ((width > 0) && (height > 0)) {
			gdk_draw_rectangle(Waap_pixmap,
								Waap_gc_color[1],
								TRUE,
								0, 0,
								width, height);

			waap_draw_page(0, 0, width, height);

			gdk_draw_pixmap(Waap_darea->window,
				Waap_darea->style->fg_gc[GTK_WIDGET_STATE(Waap_darea)],
				Waap_pixmap,
				0, 0,
				0, 0,
				width, height);
		}
	}
}

/*===============
 *   ̾ : waa_modify_page_color_gc()
 *     ǽ : ѹ
 *    : ʤ
 */
void				waa_modify_page_color_gc(
gint				color_no			// ֹ
)
{
	gchar			*prm_key[] = {		// ѥ᡼
						WAA_PRM_KEY_GRAPHFORE,
						WAA_PRM_KEY_GRAPHBACK,
						WAA_PRM_KEY_GRAPHPAGE
					};
	GdkColormap		*cmap;				// 
	GdkColor		*temp_color;		// ѿ
	gchar			*font_name;			// ե̾

	if (Waap_pixmap != NULL) {
		cmap = gdk_colormap_get_system();

		// ɽ
		temp_color = waa_get_param(prm_key[color_no], 0);
		gdk_color_alloc(cmap, temp_color);
		gdk_gc_set_foreground(Waap_gc_color[color_no], temp_color);

		// Ⱦѥե
		gdk_font_unref(Waap_font);
		font_name = waa_get_param(WAA_PRM_KEY_FONTNAME, 0);
		Waap_font = gdk_fontset_load(font_name);

		// ѥե
		gdk_font_unref(Waap_kfont);
		font_name = waa_get_param(WAA_PRM_KEY_KANJIFONT, 0);
		Waap_kfont = gdk_fontset_load(font_name);
	}
}

/*===============
 *   ̾ : waap_create_page_window()
 *     ǽ : ڡ̲ϥɥ
 *    : ڡ̲ϥɥ
 */
static GtkWidget	*waap_create_page_window(
GtkWidget			*parent				// (I) ƥå
)
{
	GtkWidget		*page_window;		// ɥ
	GtkWidget		*draw_vbox;			// 襨ꥢܥå
	GtkWidget		*close_button;		// Ĥܥ
	GtkRequisition	requisition;		// Ĥܥ󥵥
	gint			win_width;			// ɥ
	gint			win_height;			// ɥ⤵
	gchar			*title;				// ȥʸ

	// ɥ
	title = g_strconcat(_(WAA_TT_PAGE), NULL);
	page_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(page_window), title); 
	gtk_window_set_policy(GTK_WINDOW(page_window), TRUE, TRUE, FALSE);
	gtk_signal_connect(GTK_OBJECT(page_window), "destroy",
						GTK_SIGNAL_FUNC(waap_cb_destroy_window), NULL);
	g_free(title);

	// Ĥܥ
	draw_vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(page_window), draw_vbox);
	close_button = gtk_button_new_with_label(_(WAA_STR_BTN_CLOSE));
	gtk_box_pack_start(GTK_BOX(draw_vbox),
			close_button, FALSE, FALSE, 0);
	gtk_signal_connect_object(GTK_OBJECT(close_button), "clicked",
						GTK_SIGNAL_FUNC(gtk_widget_destroy),
						GTK_OBJECT(page_window));
	gtk_signal_connect(GTK_OBJECT(close_button), "button_release_event",
						GTK_SIGNAL_FUNC(waap_cb_darea_move), NULL);
	gtk_widget_size_request(close_button, &requisition);
	win_width = (gint)waa_get_param(WAA_PRM_KEY_PAGEWIDTH, 0),
	win_height = (gint)waa_get_param(WAA_PRM_KEY_PAGEHEIGHT, 0) +
												requisition.height;
	gtk_window_set_default_size(GTK_WINDOW(page_window),
									win_width, win_height);

	// 襨ꥢ
	Waap_darea = gtk_drawing_area_new();
	gtk_box_pack_start(GTK_BOX(draw_vbox), Waap_darea, TRUE, TRUE, 0);

	gtk_widget_set_events(Waap_darea,
		GDK_POINTER_MOTION_MASK |
		GDK_BUTTON_PRESS_MASK |
		GDK_BUTTON_RELEASE_MASK |
		GDK_EXPOSE |
		GDK_CONFIGURE);
	gtk_signal_connect(GTK_OBJECT(Waap_darea), "motion_notify_event",
						GTK_SIGNAL_FUNC(waap_cb_darea_move), NULL);
	gtk_signal_connect(GTK_OBJECT(Waap_darea), "button_press_event",
						GTK_SIGNAL_FUNC(waap_cb_darea_move), NULL);
	gtk_signal_connect(GTK_OBJECT(Waap_darea), "button_release_event",
						GTK_SIGNAL_FUNC(waap_cb_darea_move), NULL);
	gtk_signal_connect(GTK_OBJECT(Waap_darea), "expose_event",
						GTK_SIGNAL_FUNC(waap_cb_darea_expose), NULL);
	gtk_signal_connect(GTK_OBJECT(Waap_darea), "configure_event",
						GTK_SIGNAL_FUNC(waap_cb_darea_config), NULL);

	return page_window;
}

/*===============
 *   ̾ : waap_cb_destroy_window()
 *     ǽ : ɥõХå
 *    : ʤ
 */
static void			waap_cb_destroy_window(void)
{
	gint			loop_cnt;			// 롼ץ
	gint			gc_size;			// 顼
	gint			vis_win;			// ɽΥɥ

	gdk_font_unref(Waap_kfont);
	Waap_kfont = NULL;
	gdk_font_unref(Waap_font);
	Waap_font = NULL;

	gc_size = sizeof(Waap_gc_color) / sizeof(Waap_gc_color[0]);
	for (loop_cnt = 0; loop_cnt < gc_size; loop_cnt++) {
		gdk_gc_destroy(Waap_gc_color[loop_cnt]);
		Waap_gc_color[loop_cnt] = NULL;
	}
	gdk_pixmap_unref(Waap_pixmap);
	Waap_pixmap = NULL;
	gtk_widget_destroy(Waap_win);
	Waap_win = NULL;

	vis_win = (gint)waa_get_param(WAA_PRM_KEY_VISWINDOW, 0);
	vis_win &= ~WAA_WINNO_PAGE;
	waa_put_param(WAA_PRM_KEY_VISWINDOW, (void *)vis_win);
}

/*===============
 *   ̾ : waap_cb_darea_move()
 *     ǽ : 襨ꥢưХå
 *    : ʤ
 */
static void			waap_cb_darea_move(
GtkWidget			*widget,			// (I) 襨ꥢ
GdkEvent			*event				// (I) ٥Ⱦ
)
{
	if (event->type == GDK_MOTION_NOTIFY) {
		wmc_window_moving();
	}
	else if (event->type == GDK_BUTTON_PRESS) {
		wmc_window_start_move(Waap_win,
			event->button.x, event->button.y);
	}
	else if (event->type == GDK_BUTTON_RELEASE) {
		wmc_window_end_move();
	}
}

/*===============
 *   ̾ : waap_cb_darea_expose()
 *     ǽ : 襨ꥢ襳Хå
 *    : FALSE= ｪλ
 */
static gint			waap_cb_darea_expose(
GtkWidget			*widget,			// (I) 襨ꥢ
GdkEventExpose		*event				// (I) ٥Ⱦ
)
{
	gdk_draw_pixmap(widget->window,
					widget->style->fg_gc[GTK_WIDGET_STATE(widget)],
					Waap_pixmap,
					event->area.x, event->area.y,
					event->area.x, event->area.y,
					event->area.width, event->area.height);

	return FALSE;
}

/*===============
 *   ̾ : waap_cb_darea_config()
 *     ǽ : 襨ꥢꥢ饤Хå
 *    : TRUE= ｪλ
 */
static gint			waap_cb_darea_config(
GtkWidget			*widget,			// (I) 襨ꥢ
GdkEventConfigure	*event				// (I) ٥Ⱦ
)
{
	gint			win_size;			// 襨ꥢ⤵

	if (Waap_pixmap) {
		gdk_pixmap_unref(Waap_pixmap);
	}
	waap_create_gc(widget);

	win_size = widget->allocation.width;
	waa_put_param(WAA_PRM_KEY_PAGEWIDTH, (void *)win_size);
	win_size = widget->allocation.height;
	waa_put_param(WAA_PRM_KEY_PAGEHEIGHT, (void *)win_size);

	Waap_pixmap = gdk_pixmap_new(widget->window,
								widget->allocation.width,
								widget->allocation.height,
								-1);
	gdk_draw_rectangle(Waap_pixmap,
						Waap_gc_color[1],
						TRUE,
						0, 0,
						widget->allocation.width,
						widget->allocation.height);
	waa_draw_page();

	return TRUE;
}

/*===============
 *   ̾ : waap_create_gc()
 *     ǽ : եåƥȤκ
 *    : ʤ
 */
static void			waap_create_gc(
GtkWidget			*widget				// (I) 襨ꥢ
)
{
	gchar			*prm_key[] = {		// ѥ᡼
						WAA_PRM_KEY_GRAPHFORE,
						WAA_PRM_KEY_GRAPHBACK,
						WAA_PRM_KEY_GRAPHPAGE
					};
	gint			loop_cnt;			// 롼ץ
	gchar			*font_name;			// ե̾
	GdkColormap		*cmap;				// 
	GdkColor		*temp_color;		// ѿ

	cmap = gdk_colormap_get_system();

	for (loop_cnt = 0; loop_cnt < 3; loop_cnt++) {
		if (!Waap_gc_color[loop_cnt]) {
			Waap_gc_color[loop_cnt] = gdk_gc_new(widget->window);
			temp_color = waa_get_param(prm_key[loop_cnt], 0);
			gdk_color_alloc(cmap, temp_color);
			gdk_gc_set_foreground(Waap_gc_color[loop_cnt], temp_color);
		}
		gdk_gc_set_line_attributes(Waap_gc_color[loop_cnt],
				(gint)WAA_GRAPH_LINEWIDTH,
				GDK_LINE_SOLID,
				GDK_CAP_NOT_LAST, GDK_JOIN_MITER);
	}

	if (!Waap_font) {
		font_name = waa_get_param(WAA_PRM_KEY_FONTNAME, 0);
		Waap_font = gdk_fontset_load(font_name);
	}
	if (!Waap_kfont) {
		font_name = waa_get_param(WAA_PRM_KEY_KANJIFONT, 0);
		Waap_kfont = gdk_fontset_load(font_name);
	}
}

/*===============
 *   ̾ : waap_draw_page()
 *     ǽ : ڡ̥
 *    : ʤ
 */
static void			waap_draw_page(
gint				pos_x,				// (I) 賫ϰ
gint				pos_y,				// (I) 賫ϰ
gint				width,				// (I) 
gint				height				// (I) ⤵
)
{
	gint			mrg_width;			// ޡ
	gint			mrg_height;			// ޡ⤵
	gint			text_x;				// ɽ(ƥ)
	gint			text_y;				// ɽ(ƥ)
	gint			text_width;			// ɽƥĹ
	gint			from_x = 0;			// ɽ
	gint			from_y = 0;			// ɽ
	gint			to_x;				// ɽ
	gint			to_y;				// ɽ
	gint			loop_cnt;			// 롼ץ
	gdouble			scale_x;			// غɸ
	gdouble			scale_y;			// ٺɸ
	gchar			draw_str[100];		// ʸ
	gint			access_num;			// 
	gint			max_access;			// 祢
	gint			page_num;			// ꤵƤڡ
	gint			disp_num;			// Τäڡ

	mrg_width = 15;
	mrg_height = 15;
	max_access = 0;
	page_num = waa_get_item_num(WAA_WINNO_PAGE);
	disp_num = 0;
	for (loop_cnt = 0; loop_cnt < page_num; loop_cnt++) {
		access_num = waa_get_access_num(WAA_WINNO_PAGE, loop_cnt);
		if (max_access < access_num) {
			max_access = access_num;
		}
		if (access_num > 0) {
			disp_num++;
		}
	}
	strcpy(draw_str, _(WAA_TT_PAGE));
	text_y = wmc_gdk_text_height(Waap_font, Waap_kfont,
							draw_str, strlen(draw_str));
	wmc_gdk_draw_text(Waap_pixmap,
					Waap_font,
					Waap_kfont,
					Waap_gc_color[0],
					0, text_y,
					draw_str, strlen(draw_str));

	scale_x = (gdouble)(width - (mrg_width * 2)) / max_access;
	scale_y = (gdouble)(height - (mrg_height * 2)) / disp_num;
	mrg_width += pos_x;
	mrg_height += pos_y;
	gdk_gc_set_line_attributes(Waap_gc_color[2],
				(gint)WAA_GRAPH_LINEWIDTH,
				GDK_LINE_SOLID,
				GDK_CAP_NOT_LAST, GDK_JOIN_MITER);
	from_x = mrg_width;
	for (loop_cnt = (page_num - 1);
		loop_cnt >= (page_num - disp_num); loop_cnt--) {
		from_y = mrg_height + (page_num - loop_cnt - 1) * scale_y;
		access_num = waa_get_access_num(WAA_WINNO_PAGE, loop_cnt);
		to_x = mrg_width + (access_num * scale_x);
		to_y = mrg_height + (page_num - loop_cnt) * scale_y;
		gdk_draw_rectangle(Waap_pixmap,
				Waap_gc_color[2],
				FALSE,
				from_x, from_y,
				(to_x - from_x), (to_y - from_y));

		// ɽ
		sprintf(draw_str, "%s (%d)",
			waa_get_disp_string(WAA_WINNO_PAGE, loop_cnt), access_num);
		text_width = wmc_gdk_text_width(Waap_font, Waap_kfont,
									draw_str, strlen(draw_str));
		text_x = mrg_width + 5;
		text_y = wmc_gdk_text_height(Waap_font, Waap_kfont,
									draw_str, strlen(draw_str));
		text_y = mrg_height + ((scale_y *
					((page_num - loop_cnt) * 2 - 1) - text_y) / 2)
					+ text_y;
		wmc_gdk_draw_text(Waap_pixmap,
					Waap_font,
					Waap_kfont,
					Waap_gc_color[0],
					text_x, text_y,
					draw_str, strlen(draw_str));
	}
}
